-- Copyright (C) 1991-2012 Altera Corporation
-- Your use of Altera Corporation's design tools, logic functions 
-- and other software and tools, and its AMPP partner logic 
-- functions, and any output files from any of the foregoing 
-- (including device programming or simulation files), and any 
-- associated documentation or information are expressly subject 
-- to the terms and conditions of the Altera Program License 
-- Subscription Agreement, Altera MegaCore Function License 
-- Agreement, or other applicable license agreement, including, 
-- without limitation, that your use is for the sole purpose of 
-- programming logic devices manufactured by Altera and sold by 
-- Altera or its authorized distributors.  Please refer to the 
-- applicable agreement for further details.

-- PROGRAM		"Quartus II 32-bit"
-- VERSION		"Version 12.0 Build 263 08/02/2012 Service Pack 2 SJ Web Edition"
-- CREATED		"Tue Aug 28 22:08:25 2012"

LIBRARY ieee;
USE ieee.std_logic_1164.all; 

LIBRARY work;

ENTITY system IS 
	PORT
	(
		rst :  IN  STD_LOGIC;
		clk :  IN  STD_LOGIC;
		d_reg :  OUT  STD_LOGIC_VECTOR(7 DOWNTO 0);
		clk_out : OUT  STD_LOGIC
	);
END system;

ARCHITECTURE bdf_type OF system IS 

COMPONENT lcpu
	PORT(rst : IN STD_LOGIC;
		 clk : IN STD_LOGIC;
		 data : INOUT STD_LOGIC_VECTOR(7 DOWNTO 0);
		 we : OUT STD_LOGIC;
		 addr : OUT STD_LOGIC_VECTOR(5 DOWNTO 0);
		 d_reg : OUT STD_LOGIC_VECTOR(7 DOWNTO 0)
	);
END COMPONENT;

COMPONENT lram
	PORT(clk : IN STD_LOGIC;
		 we : IN STD_LOGIC;
		 rst : IN STD_LOGIC;
		 addr : IN STD_LOGIC_VECTOR(5 DOWNTO 0);
		 data : INOUT STD_LOGIC_VECTOR(7 DOWNTO 0)
	);
END COMPONENT;

COMPONENT CLKDIV
	PORT
	(
		clk		:	 IN STD_LOGIC;
		rst		:	 IN STD_LOGIC;
		clk_out		:	 OUT STD_LOGIC
	);
END COMPONENT;

SIGNAL	data_synth :  STD_LOGIC_VECTOR(7 DOWNTO 0);
SIGNAL	we_synth :  STD_LOGIC;
SIGNAL	addr_synth :  STD_LOGIC_VECTOR(5 DOWNTO 0);
SIGNAL	clk_synth :  STD_LOGIC;

BEGIN 

b2v_inst : lcpu
PORT MAP(rst => rst,
		 clk => clk_synth,
		 data => data_synth,
		 we => we_synth,
		 addr => addr_synth,
		 d_reg => d_reg);

b2v_inst1 : lram
PORT MAP(clk => clk_synth,
		 we => we_synth,
		 rst => rst,
		 addr => addr_synth,
		 data => data_synth);

b2v_inst2 : CLKDIV
PORT MAP(clk => clk,
		 rst => rst,
		 clk_out => clk_synth);		 

b2v_inst3: CLKDIV
PORT MAP(clk => clk,
		 rst => rst,
		 clk_out => clk_out);	
		 
END bdf_type;